Index: uspace/lib/ui/test/menuentry.c
===================================================================
--- uspace/lib/ui/test/menuentry.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/menuentry.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,4 +35,5 @@
 #include <ui/menu.h>
 #include <ui/menubar.h>
+#include <ui/menudd.h>
 #include <ui/menuentry.h>
 #include <ui/ui.h>
@@ -75,5 +76,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -116,5 +117,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -164,5 +165,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -210,5 +211,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -229,4 +230,57 @@
 
 	e = ui_menu_entry_next(e);
+	PCUT_ASSERT_NULL(e);
+
+	ui_menu_bar_destroy(mbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_menu_entry_last() / ui_menu_entry_prev() iterate over entries in reverse */
+PCUT_TEST(last_prev)
+{
+	ui_t *ui = NULL;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t params;
+	ui_menu_bar_t *mbar = NULL;
+	ui_menu_t *menu = NULL;
+	ui_menu_entry_t *entry1 = NULL;
+	ui_menu_entry_t *entry2 = NULL;
+	ui_menu_entry_t *e;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	rc = ui_menu_bar_create(ui, window, &mbar);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mbar);
+
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(menu);
+
+	rc = ui_menu_entry_create(menu, "Foo", "F1", &entry1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(entry1);
+
+	rc = ui_menu_entry_create(menu, "Bar", "F2", &entry2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(entry2);
+
+	e = ui_menu_entry_last(menu);
+	PCUT_ASSERT_EQUALS(entry2, e);
+
+	e = ui_menu_entry_prev(e);
+	PCUT_ASSERT_EQUALS(entry1, e);
+
+	e = ui_menu_entry_prev(e);
 	PCUT_ASSERT_NULL(e);
 
@@ -265,5 +319,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -315,5 +369,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -328,5 +382,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -341,4 +395,58 @@
 }
 
+/** ui_menu_entry_selectable() returns correct value based on entry type */
+PCUT_TEST(selectable)
+{
+	ui_t *ui = NULL;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t params;
+	ui_menu_bar_t *mbar = NULL;
+	ui_menu_t *menu = NULL;
+	ui_menu_entry_t *mentry = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	rc = ui_menu_bar_create(ui, window, &mbar);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mbar);
+
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(menu);
+
+	/* Selectable entry */
+
+	rc = ui_menu_entry_create(menu, "Foo", "F1", &mentry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mentry);
+
+	PCUT_ASSERT_TRUE(ui_menu_entry_selectable(mentry));
+
+	ui_menu_entry_destroy(mentry);
+
+	/* Non-selectable separator entry */
+
+	rc = ui_menu_entry_sep_create(menu, &mentry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mentry);
+
+	PCUT_ASSERT_FALSE(ui_menu_entry_selectable(mentry));
+
+	ui_menu_entry_destroy(mentry);
+
+	ui_menu_bar_destroy(mbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
 /** Press and release activates menu entry */
 PCUT_TEST(press_release)
@@ -369,5 +477,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -385,5 +493,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -432,5 +540,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -448,5 +556,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -500,5 +608,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -516,5 +624,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -545,33 +653,32 @@
 }
 
-/** Press event inside menu entry */
-PCUT_TEST(pos_press_inside)
-{
-	ui_t *ui = NULL;
-	ui_window_t *window = NULL;
-	ui_wnd_params_t params;
-	ui_menu_bar_t *mbar = NULL;
-	ui_menu_t *menu = NULL;
-	ui_menu_entry_t *mentry = NULL;
-	gfx_coord2_t pos;
+/** ui_menu_entry_activate() activates menu entry */
+PCUT_TEST(activate)
+{
+	ui_t *ui = NULL;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t params;
+	ui_menu_bar_t *mbar = NULL;
+	ui_menu_t *menu = NULL;
+	ui_menu_entry_t *mentry = NULL;
 	gfx_rect_t prect;
-	pos_event_t event;
-	errno_t rc;
-
-	rc = ui_create_disp(NULL, &ui);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	ui_wnd_params_init(&params);
-	params.caption = "Hello";
-
-	rc = ui_window_create(ui, &params, &window);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(window);
-
-	rc = ui_menu_bar_create(ui, window, &mbar);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(mbar);
-
-	rc = ui_menu_create(mbar, "Test", &menu);
+	test_resp_t resp;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	rc = ui_menu_bar_create(ui, window, &mbar);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mbar);
+
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -580,4 +687,7 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(mentry);
+
+	ui_menu_entry_set_cb(mentry, test_entry_cb, &resp);
+	resp.activated = false;
 
 	prect.p0.x = 0;
@@ -586,25 +696,20 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	pos.x = 0;
-	pos.y = 0;
-
-	event.type = POS_PRESS;
-	event.hpos = 4;
-	event.vpos = 4;
-
-	ui_menu_entry_pos_event(mentry, &pos, &event);
-	PCUT_ASSERT_TRUE(mentry->inside);
-	PCUT_ASSERT_TRUE(mentry->held);
-
-	ui_menu_bar_destroy(mbar);
-	ui_window_destroy(window);
-	ui_destroy(ui);
-}
-
-/** Press event outside menu entry */
-PCUT_TEST(pos_press_outside)
+	rc = ui_menu_open(menu, &prect, 0);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(resp.activated);
+	ui_menu_entry_activate(mentry);
+
+	ui_menu_entry_release(mentry);
+	PCUT_ASSERT_TRUE(resp.activated);
+
+	ui_menu_bar_destroy(mbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Press event inside menu entry */
+PCUT_TEST(pos_press_inside)
 {
 	ui_t *ui = NULL;
@@ -633,5 +738,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -646,5 +751,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -653,18 +758,18 @@
 
 	event.type = POS_PRESS;
-	event.hpos = 40;
-	event.vpos = 20;
+	event.hpos = 4;
+	event.vpos = 4;
 
 	ui_menu_entry_pos_event(mentry, &pos, &event);
-	PCUT_ASSERT_FALSE(mentry->inside);
-	PCUT_ASSERT_FALSE(mentry->held);
-
-	ui_menu_bar_destroy(mbar);
-	ui_window_destroy(window);
-	ui_destroy(ui);
-}
-
-/** Position event moving out of menu entry */
-PCUT_TEST(pos_move_out)
+	PCUT_ASSERT_TRUE(mentry->inside);
+	PCUT_ASSERT_TRUE(mentry->held);
+
+	ui_menu_bar_destroy(mbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Press event outside menu entry */
+PCUT_TEST(pos_press_outside)
 {
 	ui_t *ui = NULL;
@@ -693,5 +798,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -706,5 +811,65 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	pos.x = 0;
+	pos.y = 0;
+
+	event.type = POS_PRESS;
+	event.hpos = 40;
+	event.vpos = 20;
+
+	ui_menu_entry_pos_event(mentry, &pos, &event);
+	PCUT_ASSERT_FALSE(mentry->inside);
+	PCUT_ASSERT_FALSE(mentry->held);
+
+	ui_menu_bar_destroy(mbar);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Position event moving out of menu entry */
+PCUT_TEST(pos_move_out)
+{
+	ui_t *ui = NULL;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t params;
+	ui_menu_bar_t *mbar = NULL;
+	ui_menu_t *menu = NULL;
+	ui_menu_entry_t *mentry = NULL;
+	gfx_coord2_t pos;
+	gfx_rect_t prect;
+	pos_event_t event;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	rc = ui_menu_bar_create(ui, window, &mbar);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mbar);
+
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(menu);
+
+	rc = ui_menu_entry_create(menu, "X", "Y", &mentry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(mentry);
+
+	prect.p0.x = 0;
+	prect.p0.y = 0;
+	prect.p1.x = 0;
+	prect.p1.y = 0;
+
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -756,5 +921,5 @@
 	PCUT_ASSERT_NOT_NULL(mbar);
 
-	rc = ui_menu_create(mbar, "Test", &menu);
+	rc = ui_menu_dd_create(mbar, "Test", NULL, &menu);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(menu);
@@ -769,5 +934,5 @@
 	prect.p1.y = 0;
 
-	rc = ui_menu_open(menu, &prect);
+	rc = ui_menu_open(menu, &prect, 0);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
Index: uspace/lib/ui/test/paint.c
===================================================================
--- uspace/lib/ui/test/paint.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/paint.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -75,4 +75,13 @@
 } testgc_bitmap_t;
 
+/** Test box characters */
+static ui_box_chars_t test_box_chars = {
+	{
+		{ "A", "B", "C" },
+		{ "D", " ", "E" },
+		{ "F", "G", "H" }
+	}
+};
+
 /** Paint bevel */
 PCUT_TEST(bevel)
@@ -225,4 +234,7 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
+	center.x = 0;
+	center.y = 0;
+
 	/* Paint filled circle / upper-left half */
 	rc = ui_paint_filled_circle(gc, &center, 10, ui_fcircle_upleft);
@@ -241,4 +253,198 @@
 }
 
+/** Paint up pointing triangle */
+PCUT_TEST(up_triangle)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_up_triangle(gc, &center, 5);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint down pointing triangle */
+PCUT_TEST(down_triangle)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_down_triangle(gc, &center, 5);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint left pointing triangle */
+PCUT_TEST(left_triangle)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_left_triangle(gc, &center, 5);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint right pointing triangle */
+PCUT_TEST(right_triangle)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_right_triangle(gc, &center, 5);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint diagonal cross (X) */
+PCUT_TEST(cross)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_cross(gc, &center, 5, 1, 2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint mimimize icon */
+PCUT_TEST(minicon)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_minicon(resource, &center, 8, 6);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint maximize icon */
+PCUT_TEST(maxicon)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_maxicon(resource, &center, 8, 6);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint unmaximize icon */
+PCUT_TEST(unmaxicon)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	test_gc_t tgc;
+	gfx_coord2_t center;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	center.x = 0;
+	center.y = 0;
+
+	rc = ui_paint_unmaxicon(resource, &center, 8, 8, 3, 3);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 /** Paint text box */
 PCUT_TEST(text_box)
@@ -269,4 +475,40 @@
 	/* Paint text box */
 	rc = ui_paint_text_box(resource, &rect, ui_box_single, color);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_color_delete(color);
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint custom text box */
+PCUT_TEST(text_box_custom)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color = NULL;
+	test_gc_t tgc;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = gfx_color_new_rgb_i16(1, 2, 3, &color);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 30;
+	rect.p1.y = 40;
+
+	/* Paint text box */
+	rc = ui_paint_text_box_custom(resource, &rect, &test_box_chars, color);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -306,4 +548,40 @@
 	rc = ui_paint_text_hbrace(resource, &rect, ui_box_single,
 	    color);
+
+	gfx_color_delete(color);
+	ui_resource_destroy(resource);
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint text rectangle */
+PCUT_TEST(text_rect)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color = NULL;
+	test_gc_t tgc;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = gfx_color_new_rgb_i16(1, 2, 3, &color);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 30;
+	rect.p1.y = 40;
+
+	/* Paint text box */
+	rc = ui_paint_text_rect(resource, &rect, color, "A");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
 	gfx_color_delete(color);
Index: uspace/lib/ui/test/pbutton.c
===================================================================
--- uspace/lib/ui/test/pbutton.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/pbutton.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -63,7 +63,11 @@
 
 static void test_pbutton_clicked(ui_pbutton_t *, void *);
+static void test_pbutton_down(ui_pbutton_t *, void *);
+static void test_pbutton_up(ui_pbutton_t *, void *);
 
 static ui_pbutton_cb_t test_pbutton_cb = {
-	.clicked = test_pbutton_clicked
+	.clicked = test_pbutton_clicked,
+	.down = test_pbutton_down,
+	.up = test_pbutton_up
 };
 
@@ -90,4 +94,6 @@
 typedef struct {
 	bool clicked;
+	bool down;
+	bool up;
 } test_cb_resp_t;
 
@@ -125,4 +131,19 @@
 
 	ui_control_destroy(control);
+}
+
+/** Set flags sets internal field */
+PCUT_TEST(set_flags)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_pbutton_set_flags(pbutton, ui_pbf_no_text_depress);
+	PCUT_ASSERT_INT_EQUALS(ui_pbf_no_text_depress, pbutton->flags);
+
+	ui_pbutton_destroy(pbutton);
 }
 
@@ -169,4 +190,59 @@
 }
 
+/** Get light gets internal field */
+PCUT_TEST(get_light)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	pbutton->light = true;
+	PCUT_ASSERT_TRUE(ui_pbutton_get_light(pbutton));
+
+	pbutton->light = false;
+	PCUT_ASSERT_FALSE(ui_pbutton_get_light(pbutton));
+
+	ui_pbutton_destroy(pbutton);
+}
+
+/** Set light sets internal field */
+PCUT_TEST(set_light)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_pbutton_set_light(pbutton, true);
+	PCUT_ASSERT_TRUE(pbutton->light);
+
+	ui_pbutton_set_light(pbutton, false);
+	PCUT_ASSERT_FALSE(pbutton->light);
+
+	ui_pbutton_destroy(pbutton);
+}
+
+/** Set caption sets internal field */
+PCUT_TEST(set_caption)
+{
+	ui_pbutton_t *pbutton;
+	errno_t rc;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_STR_EQUALS("Hello", pbutton->caption);
+
+	rc = ui_pbutton_set_caption(pbutton, "World");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_STR_EQUALS("World", pbutton->caption);
+
+	ui_pbutton_destroy(pbutton);
+}
+
 /** Paint button */
 PCUT_TEST(paint)
@@ -225,4 +301,56 @@
 }
 
+/** Test ui_pbutton_down() */
+PCUT_TEST(down)
+{
+	errno_t rc;
+	ui_pbutton_t *pbutton;
+	test_cb_resp_t resp;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Down with no callbacks set */
+	ui_pbutton_clicked(pbutton);
+
+	/* Down with callback not implementing down */
+	ui_pbutton_set_cb(pbutton, &dummy_pbutton_cb, NULL);
+	ui_pbutton_down(pbutton);
+
+	/* Down with real callback set */
+	resp.down = false;
+	ui_pbutton_set_cb(pbutton, &test_pbutton_cb, &resp);
+	ui_pbutton_down(pbutton);
+	PCUT_ASSERT_TRUE(resp.down);
+
+	ui_pbutton_destroy(pbutton);
+}
+
+/** Test ui_pbutton_up() */
+PCUT_TEST(up)
+{
+	errno_t rc;
+	ui_pbutton_t *pbutton;
+	test_cb_resp_t resp;
+
+	rc = ui_pbutton_create(NULL, "Hello", &pbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Up with no callbacks set */
+	ui_pbutton_clicked(pbutton);
+
+	/* Up with callback not implementing up */
+	ui_pbutton_set_cb(pbutton, &dummy_pbutton_cb, NULL);
+	ui_pbutton_up(pbutton);
+
+	/* Up with real callback set */
+	resp.up = false;
+	ui_pbutton_set_cb(pbutton, &test_pbutton_cb, &resp);
+	ui_pbutton_up(pbutton);
+	PCUT_ASSERT_TRUE(resp.up);
+
+	ui_pbutton_destroy(pbutton);
+}
+
 /** Press and release button */
 PCUT_TEST(press_release)
@@ -247,4 +375,6 @@
 
 	resp.clicked = false;
+	resp.down = false;
+	resp.up = false;
 	ui_pbutton_set_cb(pbutton, &test_pbutton_cb, &resp);
 
@@ -255,4 +385,6 @@
 	PCUT_ASSERT_TRUE(pbutton->held);
 	PCUT_ASSERT_TRUE(pbutton->inside);
+	PCUT_ASSERT_TRUE(resp.down);
+	PCUT_ASSERT_FALSE(resp.up);
 	PCUT_ASSERT_FALSE(resp.clicked);
 
@@ -260,4 +392,5 @@
 	PCUT_ASSERT_FALSE(pbutton->held);
 	PCUT_ASSERT_TRUE(pbutton->inside);
+	PCUT_ASSERT_TRUE(resp.up);
 	PCUT_ASSERT_TRUE(resp.clicked);
 
@@ -588,3 +721,17 @@
 }
 
+static void test_pbutton_down(ui_pbutton_t *pbutton, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->down = true;
+}
+
+static void test_pbutton_up(ui_pbutton_t *pbutton, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->up = true;
+}
+
 PCUT_EXPORT(pbutton);
Index: uspace/lib/ui/test/popup.c
===================================================================
--- uspace/lib/ui/test/popup.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/popup.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -64,5 +64,5 @@
 static errno_t test_ctl_paint(void *);
 static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
-static void test_ctl_unfocus(void *);
+static void test_ctl_unfocus(void *, unsigned);
 
 static ui_control_ops_t test_ctl_ops = {
@@ -91,4 +91,5 @@
 	pos_event_t pos_event;
 	bool unfocus;
+	unsigned unfocus_nfocus;
 } test_ctl_resp_t;
 
@@ -98,4 +99,6 @@
 	errno_t rc;
 	ui_t *ui = NULL;
+	ui_wnd_params_t wparams;
+	ui_window_t *window = NULL;
 	ui_popup_params_t params;
 	ui_popup_t *popup = NULL;
@@ -104,11 +107,19 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
+	ui_wnd_params_init(&wparams);
+	wparams.caption = "Hello";
+
+	rc = ui_window_create(ui, &wparams, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
 	ui_popup_params_init(&params);
 
-	rc = ui_popup_create(ui, NULL, &params, &popup);
+	rc = ui_popup_create(ui, window, &params, &popup);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(popup);
 
 	ui_popup_destroy(popup);
+	ui_window_destroy(window);
 	ui_destroy(ui);
 }
@@ -125,4 +136,6 @@
 	errno_t rc;
 	ui_t *ui = NULL;
+	ui_wnd_params_t wparams;
+	ui_window_t *window = NULL;
 	ui_popup_params_t params;
 	ui_popup_t *popup = NULL;
@@ -133,7 +146,14 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
+	ui_wnd_params_init(&wparams);
+	wparams.caption = "Hello";
+
+	rc = ui_window_create(ui, &wparams, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
 	ui_popup_params_init(&params);
 
-	rc = ui_popup_create(ui, NULL, &params, &popup);
+	rc = ui_popup_create(ui, window, &params, &popup);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(popup);
@@ -171,4 +191,5 @@
 
 	ui_popup_destroy(popup);
+	ui_window_destroy(window);
 	ui_destroy(ui);
 }
@@ -179,28 +200,34 @@
 	errno_t rc;
 	ui_t *ui = NULL;
-	ui_wnd_params_t params;
+	ui_wnd_params_t wparams;
 	ui_window_t *window = NULL;
+	ui_popup_params_t params;
+	ui_popup_t *popup = NULL;
 	ui_resource_t *res;
 	gfx_context_t *gc;
-	gfx_rect_t rect;
 
 	rc = ui_create_disp(NULL, &ui);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	ui_wnd_params_init(&params);
-	params.caption = "Hello";
-
-	rc = ui_window_create(ui, &params, &window);
+	ui_wnd_params_init(&wparams);
+	wparams.caption = "Hello";
+
+	rc = ui_window_create(ui, &wparams, &window);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(window);
 
-	res = ui_window_get_res(window);
+	ui_popup_params_init(&params);
+
+	rc = ui_popup_create(ui, window, &params, &popup);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(popup);
+
+	res = ui_popup_get_res(popup);
 	PCUT_ASSERT_NOT_NULL(res);
 
-	gc = ui_window_get_gc(window);
+	gc = ui_popup_get_gc(popup);
 	PCUT_ASSERT_NOT_NULL(gc);
 
-	ui_window_get_app_rect(window, &rect);
-
+	ui_popup_destroy(popup);
 	ui_window_destroy(window);
 	ui_destroy(ui);
@@ -212,4 +239,6 @@
 	errno_t rc;
 	ui_t *ui = NULL;
+	ui_wnd_params_t wparams;
+	ui_window_t *window = NULL;
 	ui_popup_params_t params;
 	ui_popup_t *popup = NULL;
@@ -220,7 +249,14 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
+	ui_wnd_params_init(&wparams);
+	wparams.caption = "Hello";
+
+	rc = ui_window_create(ui, &wparams, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
 	ui_popup_params_init(&params);
 
-	rc = ui_popup_create(ui, NULL, &params, &popup);
+	rc = ui_popup_create(ui, window, &params, &popup);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(popup);
@@ -251,4 +287,5 @@
 
 	ui_popup_destroy(popup);
+	ui_window_destroy(window);
 	ui_destroy(ui);
 }
@@ -305,9 +342,10 @@
 }
 
-static void test_ctl_unfocus(void *arg)
+static void test_ctl_unfocus(void *arg, unsigned nfocus)
 {
 	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
 
 	resp->unfocus = true;
+	resp->unfocus_nfocus = nfocus;
 }
 
Index: uspace/lib/ui/test/resource.c
===================================================================
--- uspace/lib/ui/test/resource.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/resource.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -134,4 +134,110 @@
 }
 
+/** ui_resource_get_font() returns the font */
+PCUT_TEST(get_font)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_font_t *font;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	font = ui_resource_get_font(resource);
+	PCUT_ASSERT_EQUALS(resource->font, font);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_is_textmode() returns the textmode flag */
+PCUT_TEST(is_textmode)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	/* To make sure let's test both true and false case */
+	resource->textmode = true;
+	PCUT_ASSERT_TRUE(ui_resource_is_textmode(resource));
+	resource->textmode = false;
+	PCUT_ASSERT_FALSE(ui_resource_is_textmode(resource));
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_get_wnd_face_color() returns window face color */
+PCUT_TEST(get_wnd_face_color)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	color = ui_resource_get_wnd_face_color(resource);
+	PCUT_ASSERT_EQUALS(resource->wnd_face_color, color);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_resource_get_wnd_text_color() returns window text color */
+PCUT_TEST(get_wnd_text_color)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_color_t *color;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	color = ui_resource_get_wnd_text_color(resource);
+	PCUT_ASSERT_EQUALS(resource->wnd_text_color, color);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 static errno_t testgc_bitmap_create(void *arg, gfx_bitmap_params_t *params,
     gfx_bitmap_alloc_t *alloc, void **rbm)
